; Do_Menu
;	Written by: Michael Williams
;			spacex@williams-net.org
;			http://spacex.wiliams-net.org
;
;	Input:
;	  hl->table laid out as shown
;
;	Output:
;	  Screen has a bar menu across the bottom (screen is NOT cleared)
;
;table:
;.dw $0x0y	;x needs to be 1 if you want the arrow in the right corner
		;y is the number of the text areas you will use
;.dw Text5	;the address of the text to go in the far right box
;.dw Text4	;the next left text
;.dw Text3	;...
;.dw Text2	;...
;.dw Text1	;the text that goes in the far left box
;
;Text1:
;.db "1!",0
;Text2:
;.db "2!",0
;Text3:
;.db "3!",0
;Text4:
;.db "4!",0
;Text5:
;.db "5!",0

Do_Menu:
  call Do_Menu_Bar
  ld c,(hl)
  inc hl
  ld b,(hl)
  inc hl
  ld a,b
  cp $01
  call z,Do_More
  ld b,c
  push hl
Loop:
  pop ix
  ld l,(ix)
  inc ix
  ld h,(ix)
  inc ix
  push ix
  call WriteText
  djnz Loop
  pop hl
  ret

WriteText:
  push bc
  ld c,$03
  ld a,b
  cp $01
  jp z,A1
  cp $02
  jp z,A2
  cp $03
  jp z,A3
  cp $04
  jp z,A4
  cp $05
  jp z,A5
  ret

A1:
  ld a,c
  jp Cont
A2:
  ld a,c
  add a,$19
  jp Cont
A3:
  ld a,c
  add a,$32
  jp Cont
A4:
  ld a,c
  add a,$4B
  jp Cont
A5:
  ld a,c
  add a,$64
  jp Cont
Cont:
  ld c,a
  ld b,$3A
  call CutString
  add a,0
  rr a
  add a,c
  ld c,a
  ld (_penCol),bc
  call _vputs
  pop bc
  ret
  

CutString:
  push hl
  push bc
  dec hl
  ld b,$00
  ld c,$15
CS_Loop:
  inc hl
  ld a,(hl)
  push hl
  call _get_vchar
  ld b,(hl)
  pop hl
  ld a,c
  cp b
  jp c,CutNow
  sub b
  ld b,$00
  ld c,a
  jp CS_Loop
  
CutNow:
  ld (hl),$00
  ld a,c
  pop bc
  pop hl
  ret

Do_Menu_Bar:
  push hl
  push de
  ld hl,Menu_Table
  ld de,$FF80
  ld bc,16
  ldir
  ld hl,Menu_Table
  ld bc,16
  ldir

  ld hl,Menu_Table+16
  ld bc,16
  ldir
  ld hl,Menu_Table+16
  ld bc,16
  ldir
  ld hl,Menu_Table+16
  ld bc,16
  ldir
  ld hl,Menu_Table+16
  ld bc,16
  ldir
  ld hl,Menu_Table+16
  ld bc,16
  ldir
  ld hl,Menu_Table+16
  ld bc,16
  ldir

  pop de
  pop hl
  ret

Menu_Table:
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE
.db $C0,$00,$00,$60,$00,$00,$30,$00,$00,$18,$00,$00,$0C,$00,$00,$06

Do_More:
  push hl
  push de
  ld de,$0010
  ld hl,$FFAF
  ld a,%00000000
  ld (hl),a
  add hl,de
  ld a,%00000100
  ld (hl),a
  add hl,de
  ld a,%00000110
  ld (hl),a
  add hl,de
  ld a,%00000111
  ld (hl),a
  add hl,de
  ld a,%00000110
  ld (hl),a
  add hl,de
  ld a,%00000100
  ld (hl),a
  pop de
  pop hl
  ret